/* $Id: msb.c,vmsb.c,v 1.1 1998/04/24 04:35:08 chaz Exp $ 
 *
 * Copyright   : (c) 1998 by Glenn W Carbines.  All Rights Reserved
 * File        : msb
 *
 * Authors     : Glenn W Carbines  ( chaz@tmxmelb.mhs.oz.au )
 *			: Glenn G Trigg  ( ggt@netspace.net.au )
 * Created     : 15 Feb 1998 
 *
 * Description : Motif Study Bible.
 */

#include	<stdio.h>
#include	<ctype.h>
#include        <rxposix.h>
#define __USE_BSD		/*  For strcasecmp defn */
#include        <string.h>
#undef __USE_BSD 
#include	<stdlib.h>
#include	<Xm/DialogS.h>
#include	<Xm/MainW.h>
#include	<Xm/Form.h>
#include	<Xm/Text.h>
#include	<Xm/PushBG.h>
#include	<Xm/LabelG.h>
#include	<X11/Xmu/Editres.h>
#include	<Xm/TextF.h>
#include	<Xm/RowColumn.h>
#include	<Xm/FileSB.h>
#include	<X11/Xos.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<Xm/SeparatoG.h>
#include	<Xm/CascadeB.h>
#include	<Xm/PushB.h>
#include	<Xm/PanedW.h>
#include	<Xm/List.h>

#include	"book.xbm"
#include	"bib_books.h"

static void     create_menubar(Widget);
static void     create_file_menu(Widget);
static void     create_search_menu(Widget);
static void     create_option_menu(Widget);
static void     create_search(Widget);
static void     create_text(Widget);
static void     create_text_final(Widget);
static void     create_pane(Widget);
static void     create_output(Widget);
static void     Exit_cb(Widget, XtPointer, XtPointer);
static void     Next_cb(Widget, XtPointer, XtPointer);
static void     Seek_cb(Widget, XtPointer, XtPointer);
static void     Clear_cb(Widget, XtPointer, XtPointer);
static void     option_cb(Widget, XtPointer, XtPointer);
static void	read_index(char *);
static void	findVerseAC(Widget, XEvent *, String *, Cardinal *);
static void	gain_focus(Widget, XtPointer, XtPointer);
static void	sel_callback(Widget, XtPointer, XtPointer);
static void	OT_cb(Widget, XtPointer, XtPointer);
static void	DestroyShell(Widget, XtPointer, XtPointer);

static char	*index_fname = "bib.data.idx";
static char	*choice = "bib.data";

static FILE	*bib_fd;

static Widget	toplevel, text_output, text_edit, text_edit_final;
static Widget	search_text, pane;

static XtActionsRec actions[] = {
    {"FindVerse",	(XtActionProc)findVerseAC}
};

/*----------------------------------------------------------------------*/

int
main(int argc, char *argv[])
{
    
    Widget        main_w, form;
    XtAppContext  app_context;

    read_index(index_fname);

    if( ( bib_fd = fopen(choice, "r") ) == NULL ) {
	printf("Warning: Couldn't open %s for input\n", choice);
	return 1;
    }

    XtSetLanguageProc (NULL, NULL, NULL);

    /* initialize toolkit and create toplevel shell */
    toplevel = XtVaAppInitialize (&app_context, "msb", NULL, 0,
				  &argc, argv, NULL, NULL);

    /* Add editres support here */
    XtAddEventHandler (toplevel, 0, True, _XEditResCheckMessages, NULL);
    
    XtSetLanguageProc (NULL, NULL, NULL);
    		
    /* MainWindow for the application*/ 
    main_w = XtVaCreateManagedWidget ("main_w", xmMainWindowWidgetClass,
				      toplevel, NULL);

    create_menubar(main_w);
 
    /* create a form work area */
    /* Leave this here so we actually have form (the variable) to pass
       to the three functions below. */
    form = XtVaCreateManagedWidget ("form",
				    xmFormWidgetClass, main_w, NULL);
    XtVaSetValues (main_w, XmNworkWindow, form, NULL);

    create_search(form);
    create_output(form);
    create_pane(form);

    XtAppAddActions(app_context, actions, XtNumber(actions));

    XtRealizeWidget (toplevel);
    XtAppMainLoop (app_context);

    return 0;
} 

void 
Next_cb (Widget w, XtPointer client_data, XtPointer call_data)
{
    char		*search_pat, *p, *string, buf[256];
    XmTextPosition	pos = 0;
    int			len;
    Boolean		found = False;

    /* get the text that is about to be searched */
    if (!(string = XmTextGetString (text_edit)) || !*string) {
        XmTextSetString (text_output, "No text to search.");
        XtFree (string); /* may have been ""; free it */
        return;
    }
    /* get the pattern we're going to search for in the text. */
    if (!(search_pat = XmTextGetString (search_text)) || !*search_pat) {
        XmTextSetString (text_output, "Specify a search pattern.");
        XtFree (string); /* this we know is a string; free it */
        XtFree (search_pat); /* this may be "", XtFree() checks.. */
        return;
    }
    len = strlen (search_pat);

    /* start searching at current cursor position + 1 to find
     * the -next- occurrance of string.  we may be sitting on it.
     */
    pos = XmTextGetCursorPosition (text_edit);
    for (p = &string[pos+1]; (p = strchr (p, *search_pat)) != NULL; p++) {
        if (!strncmp (p, search_pat, len)) {
            found = True;
            break;
        }
    }
    if (!found) { /* didn't find pattern? */
        /* search from beginning till we've passed "pos" */
        for (p = string;
	     (p = index (p, *search_pat)) && p - string <= pos; p++)
            if (!strncmp (p, search_pat, len)) {
                found = True;
                break;
            }
    }
    if (!found)
        XmTextSetString (text_output, "Pattern not found.");
    else {
        pos = (XmTextPosition)(p - string);
        sprintf (buf, "Pattern found at position %ld.", pos);
        XmTextSetString (text_output, buf);
        XmTextSetInsertionPosition (text_edit, pos);
    }
    XtFree (string);
    XtFree (search_pat);

}

void
Seek_cb (Widget w, XtPointer client_data, XtPointer call_data)
{
   
    char		*search_pat, *string, buf[BUFSIZ]; 
    XmTextPosition	pos = 0;
    int			nfound =0;
    int			len;
    Boolean		found = False;
    
    FILE *input;
    input = fopen(choice,"r");

    XmTextSetString (text_edit, NULL);
 
    search_pat = XmTextGetString (search_text);

    if (!(search_pat = XmTextGetString (search_text)) || !*search_pat) {
	XmTextSetString (text_output, ". . . what am I looking for, again?!");
	XtFree (search_pat);
	return;
    }

 
    while( fgets(buf, BUFSIZ -1, input) !=NULL ) {
	if( strstr(buf, search_pat) !=NULL ) {     

	    pos = XmTextGetLastPosition (text_edit);

	  
	    XmTextInsert (text_edit, pos, buf);
	    XmTextInsert (text_edit, pos, "\n");
	  
	}

    }
	
    string = XmTextGetString (text_edit);
    len = strlen (search_pat);
	
    XmTextSetCursorPosition (text_edit, 0);

    pos = XmTextGetCursorPosition (text_edit);
		
    do {
	found = XmTextFindString (text_edit, pos, search_pat,
				  XmTEXT_FORWARD, &pos);
                  
	if (found) XmTextSetHighlight (text_edit, pos, pos + len,
				       XmHIGHLIGHT_SELECTED), nfound++;
	pos++;
		    
    }
	   
    while (found);       

    sprintf (buf, "Found %d occurrences.", nfound);
    XmTextSetString (text_output, buf);
  
    XtFree (string);	       
    XtFree (search_pat);
}
    
void 
Clear_cb (Widget w, XtPointer client_data, XtPointer call_data)
{
    XmTextPosition pos = 0;
    pos = XmTextGetLastPosition (text_edit);
    XmTextSetHighlight (text_edit, 0, pos, XmHIGHLIGHT_NORMAL);
}

void 
Exit_cb (Widget w, XtPointer client_data, XtPointer call_data)
{
    exit (1);
}

static void
All_cb (Widget w, XtPointer client_data, XtPointer call_data)
{
}

static Widget
GetTopShell(Widget w)
{
    while (w && !XtIsWMShell (w))
        w = XtParent (w);
    return w;
}

static void
Custom_cb (Widget w, XtPointer client_data, XtPointer call_data)
{
    char		*book_titles[66];
    Widget		custom_dialog, pane, list_w, form, widget;
    Pixel		fg, bg;
    int			i, n = XtNumber (book_titles);
    XmStringTable	str_list;
    Dimension		h;
    
    /* Set up a DialogShell as a popup window. */
    
    custom_dialog = XtVaCreatePopupShell ("Custom",
					  xmDialogShellWidgetClass,
					  GetTopShell (w),
					  XmNdeleteResponse, XmDESTROY,
					  NULL);

    /* Create a PanedWindow to manage the stuff in this dialog. */
    pane = XtVaCreateWidget ("pane", xmPanedWindowWidgetClass, custom_dialog,
			     XmNsashWidth,  1, /* PanedWindow won't let us set these to 0! */
			     XmNsashHeight, 1, /* Make small so user doesn't try to resize */
			     NULL);
    /* Create a RowColumn in the form for Label and Text widgets.
     * This is the control area.
     */
    form = XtVaCreateWidget ("form1", xmFormWidgetClass, pane, NULL);
    XtVaGetValues (form,  /* once created, we can get its colors */
		   XmNforeground, &fg,
		   XmNbackground, &bg,
		   NULL);

    str_list = (XmStringTable) XtMalloc (n * sizeof (XmString *));

    for(i = 0; i < 66; i++) { 
	str_list[i] = XmStringCreateLocalized (books[i].fullname); 
    }

    list_w = XmCreateScrolledList (form, "books", NULL, 0);
    XtVaSetValues (list_w,
		   XmNvisibleItemCount,   15,
		   XmNitemCount,          n,
		   XmNitems,              str_list,
		   XmNselectionPolicy,    XmEXTENDED_SELECT,
		   XmNleftAttachment,   XmATTACH_WIDGET,
		   XmNtopAttachment,    XmATTACH_FORM,
		   XmNrightAttachment,  XmATTACH_FORM,
		   XmNbottomAttachment, XmATTACH_FORM,
		   NULL);
    
    for (i = 0; i < n; i++)
	XmStringFree (str_list[i]);
    XtFree ((char *)str_list);

    XtAddCallback (list_w, XmNdefaultActionCallback, sel_callback, NULL);
    XtAddCallback (list_w, XmNextendedSelectionCallback, sel_callback, NULL);

    XtManageChild (list_w);
    XtManageChild (form);

    /* Create another form to act as the action area for the dialog */
    form = XtVaCreateWidget ("form2", xmFormWidgetClass, pane,
			     XmNfractionBase,    4,
			     NULL);

    widget = XtVaCreateManagedWidget ("OK",
				      xmPushButtonGadgetClass, form,
				      XmNtopAttachment,        XmATTACH_FORM,
				      XmNbottomAttachment,     XmATTACH_FORM,
				      XmNleftAttachment,       XmATTACH_POSITION,
				      XmNleftPosition,         0,
				      XmNrightAttachment,      XmATTACH_POSITION,
				      XmNrightPosition,        2,
				      XmNshowAsDefault,        True,
				      XmNdefaultButtonShadowThickness, 1,
				      NULL);
    XtAddCallback (widget, XmNactivateCallback, DestroyShell, custom_dialog);

    /* This is created with its XmNsensitive resource set to False
     * but maybe later I'll put a help button here to remind the user
     * how to pick books with 'extended select list'.
     */
    
    widget = XtVaCreateManagedWidget ("Help",
				      xmPushButtonGadgetClass, form,
				      XmNsensitive,            False,
				      XmNtopAttachment,        XmATTACH_FORM,
				      XmNbottomAttachment,     XmATTACH_FORM,
				      XmNleftAttachment,       XmATTACH_POSITION,
				      XmNleftPosition,         2,
				      XmNrightAttachment,      XmATTACH_POSITION,
				      XmNrightPosition,        4,
				      XmNshowAsDefault,        False,
				      XmNdefaultButtonShadowThickness, 1,
				      NULL);

    /* Fix the action area pane to its current height -- never let it resize */
    XtManageChild (form);

    XtVaGetValues (widget, XmNheight, &h, NULL);
    XtVaSetValues (form, XmNpaneMaximum, h, XmNpaneMinimum, h, NULL);

    XtManageChild (pane);

    XtPopup (custom_dialog, XtGrabNone);
}

/* The callback function for the "OK" button. */
static void
DestroyShell(Widget widget, XtPointer client_data, XtPointer call_data)
{
    Widget shell = (Widget) client_data;

    XtDestroyWidget(shell);
}



static void
sel_callback(Widget w, XtPointer client_data, XtPointer call_data)
{
}

static void
OT_cb(Widget w, XtPointer client_data, XtPointer call_data)
{
}

static void
NT_cb (Widget w, XtPointer client_data, XtPointer call_data) 
{
}

static void
create_menubar(Widget main_w)
{
    Widget	MenuBar;

    MenuBar = XmCreateMenuBar (main_w, "MenuBar", NULL, 0);
    XtManageChild (MenuBar);
    XtVaSetValues (main_w, XmNmenuBar, MenuBar, NULL);

    create_file_menu(MenuBar);
    create_search_menu(MenuBar);
    create_option_menu(MenuBar);		   
}

static void
create_file_menu(Widget MenuBar)
{
    Widget	PullDown, cascade, button;
    
    PullDown = XmCreatePulldownMenu (MenuBar, "FilePullDown", NULL, 0);
    cascade = XtVaCreateManagedWidget ( "File",
					xmCascadeButtonWidgetClass,
					MenuBar, XmNmnemonic, 'F',
					XmNsubMenuId, PullDown,NULL );
    XtVaSetValues (PullDown, XmNtearOffModel, XmTEAR_OFF_ENABLED, NULL);
 
    XtVaCreateManagedWidget ("separator",
			     xmSeparatorGadgetClass,
			     PullDown, NULL);
	    
    button = XtCreateManagedWidget ( "Exit",
				     xmPushButtonWidgetClass,
				     PullDown, NULL, 0);   
    XtAddCallback (button, XmNactivateCallback,
		   Exit_cb, NULL );
}

static void
create_search_menu(Widget MenuBar)
{
    Widget	PullDown, cascade, button;

    PullDown = XmCreatePulldownMenu (MenuBar, "SearchPullDown", NULL, 0);

    cascade = XtVaCreateManagedWidget ( "Search",
					xmCascadeButtonWidgetClass,
					MenuBar, XmNmnemonic, 'S',
					XmNsubMenuId, PullDown,
					NULL );
    XtVaSetValues (PullDown, XmNtearOffModel, XmTEAR_OFF_ENABLED, NULL);
    
    button = XtCreateManagedWidget ( "Find Next",
				     xmPushButtonWidgetClass,
				     PullDown, NULL, 0);
    XtAddCallback ( button, XmNactivateCallback,
                    Next_cb, NULL );


    button = XtCreateManagedWidget ( "Seek All",
				     xmPushButtonWidgetClass,
				     PullDown, NULL, 0);
    XtAddCallback ( button, XmNactivateCallback,
                    Seek_cb, NULL );
     
    button = XtCreateManagedWidget ( "Clear All",
				     xmPushButtonWidgetClass,
				     PullDown, NULL, 0);
    XtAddCallback ( button, XmNactivateCallback,
                    Clear_cb, NULL ); 
}

static void
create_option_menu(Widget MenuBar)
{
    Widget	PullDown, cascade, button;

    PullDown = XmCreatePulldownMenu (MenuBar, "OptionPullDown", NULL, 0);
    
    cascade = XtVaCreateManagedWidget ( "Books",
					xmCascadeButtonWidgetClass,
					MenuBar, XmNmnemonic, 'B',
					XmNsubMenuId, PullDown,
					NULL );
    XtVaSetValues (PullDown, XmNtearOffModel, XmTEAR_OFF_ENABLED, NULL);
    
    button = XtCreateManagedWidget ( "All",
				     xmPushButtonWidgetClass,
				     PullDown, NULL, 0);
    XtAddCallback ( button, XmNactivateCallback,
                    All_cb, NULL );

    button = XtCreateManagedWidget ( "Custom",
				     xmPushButtonWidgetClass,
				     PullDown, NULL, 0);
    XtAddCallback ( button, XmNactivateCallback,
                    Custom_cb, NULL );

    button = XtCreateManagedWidget ( "O.T.",
				     xmPushButtonWidgetClass,
				     PullDown, NULL, 0);
    XtAddCallback ( button, XmNactivateCallback,
                    OT_cb, NULL );

    button = XtCreateManagedWidget ( "N.T.",
				     xmPushButtonWidgetClass,
				     PullDown, NULL, 0);
    XtAddCallback ( button, XmNactivateCallback,
                    NT_cb, NULL );
}

static void
create_search(Widget parent)
{
    Widget	search_panel, seek_but, book_panel, label;
    Pixmap	pixmap;
    Pixel	fg, bg;
    XmString	book_choice, OTNT, OT, NT, Custom;
    
    /* create horizontal RowColumn inside the form */
    search_panel = XtVaCreateWidget ("search_panel",
				     xmRowColumnWidgetClass, parent,
				     NULL);

    XtVaGetValues (search_panel,
		   XmNforeground, &fg,
		   XmNbackground, &bg,
		   NULL);

    pixmap = XCreatePixmapFromBitmapData (XtDisplay (search_panel),
					  RootWindowOfScreen (XtScreen (search_panel)),
					  book_bits, book_width, book_height,
					  fg, bg, DefaultDepthOfScreen (XtScreen (search_panel)));
    label = XtVaCreateManagedWidget ("label", xmLabelGadgetClass, search_panel,
				     XmNlabelType,		 XmPIXMAP,
				     XmNlabelPixmap,		 pixmap,
				     NULL); 
    
    /* Create TextField widget with Label */
    XtVaCreateManagedWidget ("Search:",
			     xmLabelGadgetClass, search_panel, NULL);
    search_text = XtVaCreateManagedWidget ("search_text",
					   xmTextFieldWidgetClass, search_panel, NULL);

    seek_but = XtVaCreateManagedWidget ("Seek",
					xmPushButtonWidgetClass, search_panel, NULL);
    
    XtAddCallback (seek_but, XmNactivateCallback, Seek_cb, NULL);

    book_choice = XmStringCreateLocalized ("Book Choice:");
    OTNT = XmStringCreateLocalized ("OT&NT");
    OT = XmStringCreateLocalized ("OT");
    NT = XmStringCreateLocalized ("NT");
    Custom = XmStringCreateLocalized ("Custom");
    
    book_panel = XmVaCreateSimpleOptionMenu (search_panel, "Book Choice",
					     book_choice, 'C', 0, option_cb,
					     XmVaPUSHBUTTON, OTNT, 'A', NULL, NULL,
					     XmVaPUSHBUTTON, OT, 'O', NULL, NULL,
					     XmVaPUSHBUTTON, NT, 'N', NULL, NULL,
					     XmVaPUSHBUTTON, Custom, 'C', NULL, NULL,	     
					     NULL);

    
    XmStringFree (OTNT);
    XmStringFree (OT);
    XmStringFree (NT); 
    XmStringFree (book_choice);
    XmStringFree (Custom);
    XtManageChild (book_panel);
        
    XtManageChild (search_panel);
}

static void
create_pane(Widget parent)
{
    pane = XtVaCreateWidget ("pane",
			     xmPanedWindowWidgetClass, parent,
			     NULL);

    XtVaSetValues (pane, XmNorientation, XmHORIZONTAL,
		   NULL);
	       
    create_text(pane);
    create_text_final(pane); 
	
    XtManageChild (pane);
}

static void
create_text(Widget parent)
{
    text_edit = XmCreateScrolledText (parent, "textedit", NULL, 0);
	   
    XtAddCallback(text_edit, XmNfocusCallback, gain_focus, NULL);
	   
    XtManageChild (text_edit);
}

static void
create_text_final(Widget parent)
{
    text_edit_final = XmCreateScrolledText (parent, "text_edit_final",
					    NULL, 0);
    XtManageChild (text_edit_final);
}

static void
create_output(Widget parent)
{
    text_output = XtVaCreateManagedWidget ("text_output",
					   xmTextFieldWidgetClass, parent,
					   NULL);
}

static void
option_cb (Widget menu_item, XtPointer client_data, XtPointer call_data)
{
    int item_no = (int) client_data;

    if (item_no ==0)
	choice = "bib.data";

    /* Maybe something like this . . . orr a bunch of ifs orrrr what */

    switch(item_no){
    case 0: choice = "bib.data";
	break;
    case 1: XmTextSetString (text_output, "OT Selected");
	break;
    case 2: XmTextSetString (text_output, "NT Selected");
	break;
    case 3: XmTextSetString (text_output, "Prickle Bottom");
	break;
    }
}
 
static void
read_index(char *index_name)
{
    FILE	*fp;

    if( (fp = fopen(index_name, "r")) == NULL ) {
	fprintf(stderr, "Can't read from index file (%s).\n", index_name);
	return;
    }

    if( fread(verse_index, sizeof(verse_index), 1, fp) != 1 ) {
	fprintf(stderr, "Error reading index array, incomplete index file!\n");
	return;
    }
    if( fread(books, sizeof(books), 1, fp) != 1 ) {
	fprintf(stderr, "Error reading book info, incomplete index file!\n");
	return;
    }

    fclose(fp);
}

/* Find the absolute verse number given the book (Gen = 1), chapter & verse. */
/* (The books[].abbrev will probably come in useful for going from something
   like 2Cor to the actual book number. Return -1 for errors. */
static long
find_verse(int book, int chapter, int verse)
{
    int		i;
    int		vcount = 0;	/* verse count */

    /* Need to find the total number of verses preceeding this reference. */

    /* First tally up all complete books before the given one. */
    if((book < 1) || (book > 66)) {
	return -1L;		/* Error condition. */
    }
    for(i = 0; i < book - 1; i++) {
	vcount += books[i].total_verses;
    }

    /* Then tally up the chapters before the given one. */
    if((chapter < 1) || (chapter > books[book - 1].num_chapters)) {
	return -1L;		/* Error condition. */
    }
    for(i = 0; i < chapter - 1; i++) {
	vcount += books[book - 1].verse_count[i];
    }

    /* Then the verses. */
    if((verse < 1) || (verse > books[book - 1].verse_count[chapter - 1])) {
	return -1L;
    }
    vcount += verse - 1;

    return verse_index[vcount];		/* This is then used with the big array */
				/* of file positions for each verse to */
				/* position the file pointer at the required */
				/* verse. */
}

/* Take a book abbreviation and return the book number. Eg:
   Gen -> 1, Exo -> 2, Rev -> 66, etc. */
static int
book_num(char *abbrev)
{
    int		i;

    for(i = 0; i < 66; i++) {
	if(strcasecmp(abbrev, books[i].abbrev) == 0)
	    return(i + 1);
    }

    return -1;			/* -1 indicates failure. */
}

static void
findVerseAC(Widget w, XEvent *event, String *strings, Cardinal *num_strings)
{
    char		vstart[21];
    XmTextPosition	pos = 0, start, end;
    int			j;
    int			ret;
    int			chp, vrs;
    char		book[8], chap[4], vrse[4];
    char		verse[BUFSIZ];
    long		offset;
    regex_t		re;
    regmatch_t		rm[4];

    ret = regcomp(&re, "^([[:digit:]]?[[:alpha:]]+)([[:digit:]]+):([[:digit:]]+)", REG_EXTENDED);

    if( ret != 0 ) {
        fprintf(stderr, "Couldn't compile regexp.\n");
        return;
    }

    pos = XmTextXYToPos(w, event->xbutton.x, event->xbutton.y);
    if(XmTextFindString(w, pos, "\n", XmTEXT_BACKWARD, &start)) {
	start++;
    }
    else {
	start = 0;
    }
    
    if( ! XmTextFindString(w, start, " ", XmTEXT_FORWARD, &end)) {
	end = start + 10;
    }
	
    XmTextGetSubstring(w, start, end - start, 20, vstart);

    ret = regexec(&re, vstart, 4, rm, 0);
    if(ret != 0) {
	XmTextSetString (text_output, "Doh!");          
    }

    strncpy(book, &vstart[rm[1].rm_so], rm[1].rm_eo - rm[1].rm_so);
    book[rm[1].rm_eo - rm[1].rm_so] = '\0';

    strncpy(chap, &vstart[rm[2].rm_so], rm[2].rm_eo - rm[2].rm_so);
    chap[rm[2].rm_eo - rm[2].rm_so] = '\0';

    strncpy(vrse, &vstart[rm[3].rm_so], rm[3].rm_eo - rm[3].rm_so);
    vrse[rm[3].rm_eo - rm[3].rm_so] = '\0';
	   
    chp = atoi(chap);
    vrs = atoi(vrse);

    /*     sprintf (buf, "Cursor is  at position %ld (%d, %d). Ref: %s", pos, */
    /* 	     event->xbutton.x, event->xbutton.y, vstart); */
    /*     XmTextSetString (text_output, buf); */
    /*     XmTextSetInsertionPosition (text_edit, pos); */
	   
    /* printf("Verse seek value: %ld\n" */
    offset = find_verse(book_num(book), chp, vrs);
	  
    if(bib_fd != NULL) {
	if( offset == -1L ) {
	    XmTextSetString (text_output, ".....Doh!");	   
	}
	else {
	    fseek(bib_fd, offset, 0);
	    XmTextSetString (text_edit_final, NULL);

	    for(j=0; j < 12; j++)  {
		if (fgets(verse, BUFSIZ-1, bib_fd) == NULL)
		    return;
		pos = XmTextGetLastPosition (text_edit_final);
		/*    XmTextInsert (text_edit_final, pos, "\n"); */
		XmTextInsert (text_edit_final, pos, verse);
		XmTextSetCursorPosition (text_edit_final, 0);
	    }
		
	}

    }
}

static void
gain_focus(Widget text_edit, XtPointer client_data, XtPointer call_data)
{
    XmTextShowPosition (text_edit, XmTextGetCursorPosition (text_edit));
}

